Package ghidra.pcode.emu.jit

# Enum Class JitCompiler.Diag

java.lang.Object
java.lang.Enum<JitCompiler.Diag>
ghidra.pcode.emu.jit.JitCompiler.Diag

All Implemented Interfaces:
  `Serializable`, `Comparable<JitCompiler.Diag>`, `Constable`

Enclosing class:
  `JitCompiler`

public static enum JitCompiler.Diag extends Enum<JitCompiler.Diag>
Diagnostic toggles

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `DUMP_CLASS`
  Save the generated `.class` file to disk for offline examination
  `PRINT_CFM`
  Print the contents (p-code) of each basic block and flows/branches among them
  `PRINT_DFM`
  Print the ops of each basic block in SSA (sort of) form
  `PRINT_OUM`
  Print each eliminated op
  `PRINT_PASSAGE`
  Print each passage (instructions and p-code ops) before translation
  `PRINT_SYNTH`
  Print each synthetic operation, e.g., catenation, subpiece, phi
  `PRINT_VSM`
  Print the list of live variables for each basic block
  `TRACE_CLASS`
  Enable ASM's trace for each generated classfile

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static JitCompiler.Diag`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static JitCompiler.Diag[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### PRINT_PASSAGE

    public static final JitCompiler.Diag PRINT_PASSAGE
    Print each passage (instructions and p-code ops) before translation

  - ### PRINT_CFM

    public static final JitCompiler.Diag PRINT_CFM
    Print the contents (p-code) of each basic block and flows/branches among them

  - ### PRINT_DFM

    public static final JitCompiler.Diag PRINT_DFM
    Print the ops of each basic block in SSA (sort of) form

  - ### PRINT_VSM

    public static final JitCompiler.Diag PRINT_VSM
    Print the list of live variables for each basic block

  - ### PRINT_SYNTH

    public static final JitCompiler.Diag PRINT_SYNTH
    Print each synthetic operation, e.g., catenation, subpiece, phi

  - ### PRINT_OUM

    public static final JitCompiler.Diag PRINT_OUM
    Print each eliminated op

  - ### TRACE_CLASS

    public static final JitCompiler.Diag TRACE_CLASS
    Enable ASM's trace for each generated classfile

  - ### DUMP_CLASS

    public static final JitCompiler.Diag DUMP_CLASS
    Save the generated `.class` file to disk for offline examination

- ## Method Details

  - ### values

    public static JitCompiler.Diag[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static JitCompiler.Diag valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null